﻿Option Strict On
Imports System.IO
Public Class Form1
    Dim suche As Integer = 0
    Dim listboxx1 As New List(Of String)
    Dim errorlogg As New List(Of String)
    Dim elapsed As Double = 0
    Dim nowProgressBar As Integer = 0
    Dim maxProgressBar As Integer = 0
    Dim verzeichnis As String = "C:\"
    Dim WithEvents BGW As New System.ComponentModel.BackgroundWorker With {.WorkerReportsProgress = True, .WorkerSupportsCancellation = True}



    Private Sub suchen_Click(sender As Object, e As EventArgs) Handles suchen.Click
        If Not BGW.IsBusy Then
            status.Text = "Bitte warten..."
            cancel.Enabled = True
            suchen.Enabled = False
            ' ausfuhren()
            BGW.RunWorkerAsync()
            PBLoading.Visible = True
            elapsed = 0
            Timer2.Start()
        End If



    End Sub

    Private Sub setdirectory_Click(sender As Object, e As EventArgs) Handles setdirectory.Click
        FolderBrowserDialog1.ShowDialog()
        verzeichnis = FolderBrowserDialog1.SelectedPath
        pfadBox.Text = verzeichnis
    End Sub

    Private Sub clearlist_Click(sender As Object, e As EventArgs) Handles clearlist.Click
        'Momentan arbeite ich mit keiner Listbox, da ich gerade auf DataGridView umstelle!
        ListBox1.Items.Clear()
    End Sub



    Private Sub BGW_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BGW.DoWork

        Dim di As New DirectoryInfo(verzeichnis)
        Dim fiArr As FileInfo()
        Dim fri As FileInfo
        Dim MySize As Long
        Dim fiArrDetail As DirectoryInfo()
        Dim friDetail As DirectoryInfo
        Dim byti As Long = 1000000
        Try
            fiArr = di.GetFiles(("*"), SearchOption.AllDirectories)
            maxProgressBar = CInt(fiArr.Length)
        Catch ex As Exception
            'Alle Directories
            fiArrDetail = di.GetDirectories()
            For Each friDetail In fiArrDetail
                Try
                    di = New DirectoryInfo(friDetail.FullName)
                    fiArr = di.GetFiles(("*"), SearchOption.AllDirectories)
                    maxProgressBar += CInt(fiArr.Length)

                    For Each fri In fiArr
                        suche = suche + 1
                        BGW.ReportProgress(CInt(suche / maxProgressBar * 100))
                        MySize = FileLen(fri.DirectoryName & "\" & fri.Name)
                        If MySize >= NUD.Value * byti Then
                            Dim grosse As Long = CLng(Math.Round(MySize / 1000000, 0))
                            listboxx1.Add(fri.DirectoryName & "\" & fri.Name & " (" & grosse & " MB)")
                        End If


                    Next fri
                Catch ex1 As Exception
                    errorlogg.Add(ex.Message)
                End Try

            Next friDetail

            'Alle Files der obersten Ebene
            Try
                fiArr = di.GetFiles(("*"), SearchOption.TopDirectoryOnly)


            Catch ex2 As Exception
            End Try
        End Try
        For Each fri In fiArr
            MySize = FileLen(fri.DirectoryName & "\" & fri.Name)
            If MySize >= NUD.Value * byti Then
                Dim grosse As Long = CLng(Math.Round(MySize / 1000000, 0))
                listboxx1.Add(fri.DirectoryName & "\" & fri.Name & " (" & grosse & " MB)")
                suche = suche + 1
                BGW.ReportProgress(CInt(suche / maxProgressBar * 100))
            End If

        Next fri


    End Sub









    Private Sub BGW_ProgressChanged(sender As System.Object, e As System.ComponentModel.ProgressChangedEventArgs) Handles BGW.ProgressChanged

        Fortschritt.Maximum = maxProgressBar
        If e.ProgressPercentage < maxProgressBar Then
            Me.Fortschritt.Value = e.ProgressPercentage
            Me.Fortschritt.Update()
        End If
    End Sub

    Private Sub BGW_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BGW.RunWorkerCompleted
        status.Text = "Vorgang abgeschlossen"
        suchen.Enabled = True
        Me.Fortschritt.Value = Fortschritt.Maximum
        For Each lb In listboxx1
            ListBox1.Items.Add(lb)
        Next
        Timer1.Enabled = True
        suche1.Text = CType(suche, String)
        listboxx1.Clear()
        suche1.Text = CType(suche, String)
        PBLoading.Visible = False
        Timer2.Stop()
        ps.Text = Math.Round(suche / elapsed, 0) & " pro Sekunde"
        suche = 0
        If errorlogg.Count > 0 Then
            Dim message As String = ""
            For Each error1 In errorlogg
                message += vbCrLf & error1

            Next
            MsgBox("Einige Verzeichnisse konnten aufgrund ihrer Berechtigungen nicht gescannt werden!" + vbCrLf + message, MsgBoxStyle.Critical, "Fehler")
        End If

        errorlogg.Clear()
        cancel.Enabled = False
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False
        status.Text = "Warte auf Input"
        Fortschritt.Value = 0
    End Sub


    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles exportlist.Click
        'Momentan arbeite ich mit keiner Listbox, da ich gerade auf DataGridView umstelle!
        For Each flie In ListBox1.Items
            My.Computer.FileSystem.WriteAllText(Application.StartupPath() & "\BigFileFinder.txt", CType(flie, String) & vbCrLf, True)
        Next
        MessageBox.Show("Die Liste wurde in dem Ordner der Applikation abgespeichert!", "Gespeichert!", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub clearexport_Click(sender As Object, e As EventArgs) Handles clearexport.Click
        Try
            My.Computer.FileSystem.DeleteFile(Application.StartupPath() & "\BigFileFinder.txt")
            MessageBox.Show("Die Liste wurde geleert und gelöscht!", "Gelöscht!", MessageBoxButtons.OK, MessageBoxIcon.Information)

        Catch ex As Exception

        End Try
    End Sub

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        elapsed = elapsed + 0.1
        suche1.Text = CType(suche, String)
    End Sub

    Private Sub cancel_Click(sender As Object, e As EventArgs) Handles cancel.Click
        BGW.CancelAsync()
    End Sub
End Class
